#!/bin/sh
#  _    _          ___           __ _     (R)
# | |  (_)_ _____ / __|___ _ _  / _(_)__ _
# | |__| \ V / -_) (__/ _ \ ' \|  _| / _` |
# |____|_|\_/\___|\___\___/_||_|_| |_\__, |
#                                    |___/
# Copyright (c) 2009-2015 Keppler IT GmbH.
# ----------------------------------------------------------------------------
# common/tools/uploadscan.sh
# $Id$
# 
# Wrapper script to scan files uploaded via PHP
# Thanks to Stefan Esser & Suhosin Team for this great work!
# http://www.php-mag.de/itr/online_artikel/psecom,id,978,nodeid,62,_language,de.html
#
# For best results you should install the great software "Linux Malware Detect"
# http://www.rfxn.com/projects/linux-malware-detect/
# !!!IMPORTANT!!!
# Since the maldet update from 09/2015, scanning as web user doesn't work any
# more due to permission problems. Nevertheless, LMD (maldet) still installs
# its signatures in /var/lib/clamav, so we simply use "clamdscan" :-)
# THIS REQUIRES YOU TO HAVE THE "clamav-daemon" PACKAGE INSTALLED!
# 
# ----------------------------------------------------------------------------

PATH="/usr/bin:/bin"
FILE="$1"

# check if "clamd" is running
CLAMD=`pidof clamd 2>/dev/null`

if [ "$CLAMD" ]; then
	# check for 'clamdscan' command
	CLAMDSCAN=`which clamdscan 2>/dev/null`
	if [ -x "$CLAMDSCAN" ]; then
		# scan file using clamdscan:
		if [ -n "`$CLAMDSCAN --fdpass --infected --no-summary \"$FILE\"`" ]; then
			# virus/malware found!
			echo "0"
			exit
		fi
	fi
fi

# default: allow upload...
echo 1

# <EOF>-----------------------------------------------------------------------
